
{******************************************}
{                                          }
{          Liaison de donnes XML          }
{                                          }
{         Gnr le : 07/12/2007 09:44:29  }
{       Gnr depuis : params.xml         }
{   Paramtres stocks dans : params.xdb   }
{                                          }
{******************************************}

unit params;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ Dcl. Forward }

  IXMLParamsType = interface;
  IXMLLangsType = interface;
  IXMLLangType = interface;
  IXMLId_profsType = interface;
  IXMLProfType = interface;
  IXMLId_attrsType = interface;
  IXMLAttrType = interface;
  IXMLProfessionsType = interface;
  IXMLProfessionType = interface;
  IXMLAttributesType = interface;
  IXMLAttributeType = interface;
  IXMLSkillsType = interface;
  IXMLSkillType = interface;

{ IXMLParamsType }

  IXMLParamsType = interface(IXMLNode)
    ['{09B92262-6D09-40C5-9623-D83057B26145}']
    { Accesseurs de proprits }
    function Get_Langs: IXMLLangsType;
    function Get_Id_profs: IXMLId_profsType;
    function Get_Id_attrs: IXMLId_attrsType;
    function Get_Professions: IXMLProfessionsType;
    function Get_Attributes: IXMLAttributesType;
    function Get_Skills: IXMLSkillsType;
    { Mthodes & proprits }
    property Langs: IXMLLangsType read Get_Langs;
    property Id_profs: IXMLId_profsType read Get_Id_profs;
    property Id_attrs: IXMLId_attrsType read Get_Id_attrs;
    property Professions: IXMLProfessionsType read Get_Professions;
    property Attributes: IXMLAttributesType read Get_Attributes;
    property Skills: IXMLSkillsType read Get_Skills;
  end;

{ IXMLLangsType }

  IXMLLangsType = interface(IXMLNodeCollection)
    ['{A074DA46-77F1-4589-BEAD-7EE7BA896483}']
    { Accesseurs de proprits }
    function Get_Lang(Index: Integer): IXMLLangType;
    { Mthodes & proprits }
    function Add: IXMLLangType;
    function Insert(const Index: Integer): IXMLLangType;
    property Lang[Index: Integer]: IXMLLangType read Get_Lang; default;
  end;

{ IXMLLangType }

  IXMLLangType = interface(IXMLNode)
    ['{BC31CC43-79A2-4FE2-BE3C-056E2FAE52A0}']
    { Accesseurs de proprits }
    function Get_Key: WideString;
    function Get_Value: WideString;
    { Mthodes & proprits }
    property Key: WideString read Get_Key;
    property Value: WideString read Get_Value;
  end;

{ IXMLId_profsType }

  IXMLId_profsType = interface(IXMLNodeCollection)
    ['{A249D5B6-8047-453E-A87A-D4FA08BF5288}']
    { Accesseurs de proprits }
    function Get_Prof(Index: Integer): IXMLProfType;
    { Mthodes & proprits }
    function Add: IXMLProfType;
    function Insert(const Index: Integer): IXMLProfType;
    property Prof[Index: Integer]: IXMLProfType read Get_Prof; default;
  end;

{ IXMLProfType }

  IXMLProfType = interface(IXMLNode)
    ['{E4ABD39E-FF36-479A-8D37-389E958365BA}']
    { Accesseurs de proprits }
    function Get_Key: Integer;
    function Get_Value: WideString;
    { Mthodes & proprits }
    property Key: Integer read Get_Key;
    property Value: WideString read Get_Value;
  end;

{ IXMLId_attrsType }

  IXMLId_attrsType = interface(IXMLNodeCollection)
    ['{3E7E67A1-04F8-4F51-951E-7FE6D7160475}']
    { Accesseurs de proprits }
    function Get_Attr(Index: Integer): IXMLAttrType;
    { Mthodes & proprits }
    function Add: IXMLAttrType;
    function Insert(const Index: Integer): IXMLAttrType;
    property Attr[Index: Integer]: IXMLAttrType read Get_Attr; default;
  end;

{ IXMLAttrType }

  IXMLAttrType = interface(IXMLNode)
    ['{896811BE-6C27-41C4-AF52-E769226CA0DB}']
    { Accesseurs de proprits }
    function Get_Key: Integer;
    function Get_Value: WideString;
    { Mthodes & proprits }
    property Key: Integer read Get_Key;
    property Value: WideString read Get_Value;
  end;

{ IXMLProfessionsType }

  IXMLProfessionsType = interface(IXMLNodeCollection)
    ['{D2B87008-9FC7-492F-922D-1983351C6D3D}']
    { Accesseurs de proprits }
    function Get_Profession(Index: Integer): IXMLProfessionType;
    { Mthodes & proprits }
    function Add: IXMLProfessionType;
    function Insert(const Index: Integer): IXMLProfessionType;
    property Profession[Index: Integer]: IXMLProfessionType read Get_Profession; default;
  end;

{ IXMLProfessionType }

  IXMLProfessionType = interface(IXMLNode)
    ['{B333F448-A7BF-4F64-98C7-01C16DCE9038}']
    { Accesseurs de proprits }
    function Get_Abbr: WideString;
    function Get_Nom: WideString;
    { Mthodes & proprits }
    property Abbr: WideString read Get_Abbr;
    property Nom: WideString read Get_Nom;
  end;

{ IXMLAttributesType }

  IXMLAttributesType = interface(IXMLNodeCollection)
    ['{C19A9F75-3B50-4750-85E9-88F6DCCF8EB4}']
    { Accesseurs de proprits }
    function Get_Attribute(Index: Integer): IXMLAttributeType;
    { Mthodes & proprits }
    function Add: IXMLAttributeType;
    function Insert(const Index: Integer): IXMLAttributeType;
    property Attribute[Index: Integer]: IXMLAttributeType read Get_Attribute; default;
  end;

{ IXMLAttributeType }

  IXMLAttributeType = interface(IXMLNode)
    ['{397D10BD-BE32-414F-81DF-1A3DFE3A4152}']
    { Accesseurs de proprits }
    function Get_Abbr: WideString;
    function Get_Nom: WideString;
    function Get_Prof: WideString;
    function Get_Prof_abbr: WideString;
    { Mthodes & proprits }
    property Abbr: WideString read Get_Abbr;
    property Nom: WideString read Get_Nom;
    property Prof: WideString read Get_Prof;
    property Prof_abbr: WideString read Get_Prof_abbr;
  end;

{ IXMLSkillsType }

  IXMLSkillsType = interface(IXMLNodeCollection)
    ['{05CB7CC8-6761-4168-B086-33D87C443D51}']
    { Accesseurs de proprits }
    function Get_Skill(Index: Integer): IXMLSkillType;
    { Mthodes & proprits }
    function Add: IXMLSkillType;
    function Insert(const Index: Integer): IXMLSkillType;
    property Skill[Index: Integer]: IXMLSkillType read Get_Skill; default;
  end;

{ IXMLSkillType }

  IXMLSkillType = interface(IXMLNode)
    ['{203E276C-D121-4BDB-A999-7495904DE80E}']
    { Accesseurs de proprits }
    function Get_Id: Integer;
    function Get_Img: Integer;
    function Get_Name: WideString;
    function Get_Name_id: WideString;
    function Get_Profession: WideString;
    function Get_Prof: WideString;
    function Get_Attribute: WideString;
    function Get_Attr: WideString;
    function Get_Type_: WideString;
    function Get_Ty: WideString;
    function Get_Chapter: Integer;
    function Get_Chap: WideString;
    function Get_Pve: Integer;
    function Get_Polymock: Integer;
    function Get_Monster: Integer;
    function Get_Adrenaline: Integer;
    function Get_Energy: Integer;
    function Get_Recharge: Integer;
    function Get_Eregen: Integer;
    function Get_Casting: Extended;
    function Get_Elite: Integer;
    function Get_Desc: WideString;
    { Mthodes & proprits }
    property Id: Integer read Get_Id;
    property Img: Integer read Get_Img;
    property Name: WideString read Get_Name;
    property Name_id: WideString read Get_Name_id;
    property Profession: WideString read Get_Profession;
    property Prof: WideString read Get_Prof;
    property Attribute: WideString read Get_Attribute;
    property Attr: WideString read Get_Attr;
    property Type_: WideString read Get_Type_;
    property Ty: WideString read Get_Ty;
    property Chapter: Integer read Get_Chapter;
    property Chap: WideString read Get_Chap;
    property Pve: Integer read Get_Pve;
    property Polymock: Integer read Get_Polymock;
    property Monster: Integer read Get_Monster;
    property Adrenaline: Integer read Get_Adrenaline;
    property Energy: Integer read Get_Energy;
    property Recharge: Integer read Get_Recharge;
    property Eregen: Integer read Get_Eregen;
    property Casting: Extended read Get_Casting;
    property Elite: Integer read Get_Elite;
    property Desc: WideString read Get_Desc;
  end;

{ Dcl. Forward }

  TXMLParamsType = class;
  TXMLLangsType = class;
  TXMLLangType = class;
  TXMLId_profsType = class;
  TXMLProfType = class;
  TXMLId_attrsType = class;
  TXMLAttrType = class;
  TXMLProfessionsType = class;
  TXMLProfessionType = class;
  TXMLAttributesType = class;
  TXMLAttributeType = class;
  TXMLSkillsType = class;
  TXMLSkillType = class;

{ TXMLParamsType }

  TXMLParamsType = class(TXMLNode, IXMLParamsType)
  protected
    { IXMLParamsType }
    function Get_Langs: IXMLLangsType;
    function Get_Id_profs: IXMLId_profsType;
    function Get_Id_attrs: IXMLId_attrsType;
    function Get_Professions: IXMLProfessionsType;
    function Get_Attributes: IXMLAttributesType;
    function Get_Skills: IXMLSkillsType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLLangsType }

  TXMLLangsType = class(TXMLNodeCollection, IXMLLangsType)
  protected
    { IXMLLangsType }
    function Get_Lang(Index: Integer): IXMLLangType;
    function Add: IXMLLangType;
    function Insert(const Index: Integer): IXMLLangType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLLangType }

  TXMLLangType = class(TXMLNode, IXMLLangType)
  protected
    { IXMLLangType }
    function Get_Key: WideString;
    function Get_Value: WideString;
  end;

{ TXMLId_profsType }

  TXMLId_profsType = class(TXMLNodeCollection, IXMLId_profsType)
  protected
    { IXMLId_profsType }
    function Get_Prof(Index: Integer): IXMLProfType;
    function Add: IXMLProfType;
    function Insert(const Index: Integer): IXMLProfType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLProfType }

  TXMLProfType = class(TXMLNode, IXMLProfType)
  protected
    { IXMLProfType }
    function Get_Key: Integer;
    function Get_Value: WideString;
  end;

{ TXMLId_attrsType }

  TXMLId_attrsType = class(TXMLNodeCollection, IXMLId_attrsType)
  protected
    { IXMLId_attrsType }
    function Get_Attr(Index: Integer): IXMLAttrType;
    function Add: IXMLAttrType;
    function Insert(const Index: Integer): IXMLAttrType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLAttrType }

  TXMLAttrType = class(TXMLNode, IXMLAttrType)
  protected
    { IXMLAttrType }
    function Get_Key: Integer;
    function Get_Value: WideString;
  end;

{ TXMLProfessionsType }

  TXMLProfessionsType = class(TXMLNodeCollection, IXMLProfessionsType)
  protected
    { IXMLProfessionsType }
    function Get_Profession(Index: Integer): IXMLProfessionType;
    function Add: IXMLProfessionType;
    function Insert(const Index: Integer): IXMLProfessionType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLProfessionType }

  TXMLProfessionType = class(TXMLNode, IXMLProfessionType)
  protected
    { IXMLProfessionType }
    function Get_Abbr: WideString;
    function Get_Nom: WideString;
  end;

{ TXMLAttributesType }

  TXMLAttributesType = class(TXMLNodeCollection, IXMLAttributesType)
  protected
    { IXMLAttributesType }
    function Get_Attribute(Index: Integer): IXMLAttributeType;
    function Add: IXMLAttributeType;
    function Insert(const Index: Integer): IXMLAttributeType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLAttributeType }

  TXMLAttributeType = class(TXMLNode, IXMLAttributeType)
  protected
    { IXMLAttributeType }
    function Get_Abbr: WideString;
    function Get_Nom: WideString;
    function Get_Prof: WideString;
    function Get_Prof_abbr: WideString;
  end;

{ TXMLSkillsType }

  TXMLSkillsType = class(TXMLNodeCollection, IXMLSkillsType)
  protected
    { IXMLSkillsType }
    function Get_Skill(Index: Integer): IXMLSkillType;
    function Add: IXMLSkillType;
    function Insert(const Index: Integer): IXMLSkillType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLSkillType }

  TXMLSkillType = class(TXMLNode, IXMLSkillType)
  protected
    { IXMLSkillType }
    function Get_Id: Integer;
    function Get_Img: Integer;
    function Get_Name: WideString;
    function Get_Name_id: WideString;
    function Get_Profession: WideString;
    function Get_Prof: WideString;
    function Get_Attribute: WideString;
    function Get_Attr: WideString;
    function Get_Type_: WideString;
    function Get_Ty: WideString;
    function Get_Chapter: Integer;
    function Get_Chap: WideString;
    function Get_Pve: Integer;
    function Get_Polymock: Integer;
    function Get_Monster: Integer;
    function Get_Adrenaline: Integer;
    function Get_Energy: Integer;
    function Get_Recharge: Integer;
    function Get_Eregen: Integer;
    function Get_Casting: Extended;
    function Get_Elite: Integer;
    function Get_Desc: WideString;
  end;

{ Fonctions globales }

function Getparams(Doc: IXMLDocument): IXMLParamsType;
function Loadparams(const FileName: WideString): IXMLParamsType;
function Newparams: IXMLParamsType;
function FindSkill(id : integer): IXMLSkillType;
function GetProfById(params: IXMLParamsType; id : integer): string; 
function GetAttrById(params: IXMLParamsType; id : integer): string;
function GetAttrIdByAbbr(params: IXMLParamsType; abbr : string): integer;

const
  TargetNamespace = '';

implementation

uses main;

{ Fonctions globales }

                      
function GetAttrIdByAbbr(params: IXMLParamsType; abbr : string): integer;
var i:integer;
begin
  Result := 0;
  for i := 0 to params.Id_attrs.Count - 1 do begin
    if params.Id_attrs.Attr[i].Value=abbr then begin
      Result := params.Id_attrs.Attr[i].Key;
      break;
    end;
  end;
end;

function GetAttrById(params: IXMLParamsType; id : integer): string;
var i:integer;
begin
  Result := '';
  for i := 0 to params.Id_attrs.Count - 1 do begin
    if params.Id_attrs.Attr[i].Key=id then begin
      Result := params.Id_attrs.Attr[i].Value;
      break;
    end;
  end;
end;
  
function GetProfById(params: IXMLParamsType; id : integer): string;
var i:integer;
begin
  Result := '';
  for i := 0 to params.Id_profs.Count - 1 do begin
    if params.Id_profs.Prof[i].Key=id then begin
      Result := params.Id_profs.Prof[i].Value;
      break;
    end;
  end;
end;

function Getparams(Doc: IXMLDocument): IXMLParamsType;
begin
  Result := Doc.GetDocBinding('params', TXMLParamsType, TargetNamespace) as IXMLParamsType;
end;

function Loadparams(const FileName: WideString): IXMLParamsType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('params', TXMLParamsType, TargetNamespace) as IXMLParamsType;
end;

function Newparams: IXMLParamsType;
begin
  Result := NewXMLDocument.GetDocBinding('params', TXMLParamsType, TargetNamespace) as IXMLParamsType;
end;


function FindSkill(id : integer): IXMLSkillType;
var
  node: IDOMNode;
  xml : TXMLSkillType;
begin    
  Result := nil;
  try
    node := (Form1.GetXML.DOMDocument as IDOMNodeSelect).SelectNode('//skill[id="250"]');
    xml := TXMLSkillType.Create(node, nil, Form1.GetXML);
    Result := xml as IXMLSkillType;
  finally
  end;
  {
var
  i: integer;
begin
  result := nil;
  for i := 0 to skills.Count - 1 do begin
    if skills.Skill[i].Id = id then begin
      result := skills.Skill[i];
      break;
    end;
  end;  }
end;

{ TXMLParamsType }

procedure TXMLParamsType.AfterConstruction;
begin
  RegisterChildNode('langs', TXMLLangsType);
  RegisterChildNode('id_profs', TXMLId_profsType);
  RegisterChildNode('id_attrs', TXMLId_attrsType);
  RegisterChildNode('professions', TXMLProfessionsType);
  RegisterChildNode('attributes', TXMLAttributesType);
  RegisterChildNode('skills', TXMLSkillsType);
  inherited;
end;

function TXMLParamsType.Get_Langs: IXMLLangsType;
begin
  Result := ChildNodes['langs'] as IXMLLangsType;
end;

function TXMLParamsType.Get_Id_profs: IXMLId_profsType;
begin
  Result := ChildNodes['id_profs'] as IXMLId_profsType;
end;

function TXMLParamsType.Get_Id_attrs: IXMLId_attrsType;
begin
  Result := ChildNodes['id_attrs'] as IXMLId_attrsType;
end;

function TXMLParamsType.Get_Professions: IXMLProfessionsType;
begin
  Result := ChildNodes['professions'] as IXMLProfessionsType;
end;

function TXMLParamsType.Get_Attributes: IXMLAttributesType;
begin
  Result := ChildNodes['attributes'] as IXMLAttributesType;
end;

function TXMLParamsType.Get_Skills: IXMLSkillsType;
begin
  Result := ChildNodes['skills'] as IXMLSkillsType;
end;

{ TXMLLangsType }

procedure TXMLLangsType.AfterConstruction;
begin
  RegisterChildNode('lang', TXMLLangType);
  ItemTag := 'lang';
  ItemInterface := IXMLLangType;
  inherited;
end;

function TXMLLangsType.Get_Lang(Index: Integer): IXMLLangType;
begin
  Result := List[Index] as IXMLLangType;
end;

function TXMLLangsType.Add: IXMLLangType;
begin
  Result := AddItem(-1) as IXMLLangType;
end;

function TXMLLangsType.Insert(const Index: Integer): IXMLLangType;
begin
  Result := AddItem(Index) as IXMLLangType;
end;

{ TXMLLangType }

function TXMLLangType.Get_Key: WideString;
begin
  Result := ChildNodes['key'].Text;
end;

function TXMLLangType.Get_Value: WideString;
begin
  Result := ChildNodes['value'].Text;
end;

{ TXMLId_profsType }

procedure TXMLId_profsType.AfterConstruction;
begin
  RegisterChildNode('prof', TXMLProfType);
  ItemTag := 'prof';
  ItemInterface := IXMLProfType;
  inherited;
end;

function TXMLId_profsType.Get_Prof(Index: Integer): IXMLProfType;
begin
  Result := List[Index] as IXMLProfType;
end;

function TXMLId_profsType.Add: IXMLProfType;
begin
  Result := AddItem(-1) as IXMLProfType;
end;

function TXMLId_profsType.Insert(const Index: Integer): IXMLProfType;
begin
  Result := AddItem(Index) as IXMLProfType;
end;

{ TXMLProfType }

function TXMLProfType.Get_Key: Integer;
begin
  Result := ChildNodes['key'].NodeValue;
end;

function TXMLProfType.Get_Value: WideString;
begin
  Result := ChildNodes['value'].Text;
end;

{ TXMLId_attrsType }

procedure TXMLId_attrsType.AfterConstruction;
begin
  RegisterChildNode('attr', TXMLAttrType);
  ItemTag := 'attr';
  ItemInterface := IXMLAttrType;
  inherited;
end;

function TXMLId_attrsType.Get_Attr(Index: Integer): IXMLAttrType;
begin
  Result := List[Index] as IXMLAttrType;
end;

function TXMLId_attrsType.Add: IXMLAttrType;
begin
  Result := AddItem(-1) as IXMLAttrType;
end;

function TXMLId_attrsType.Insert(const Index: Integer): IXMLAttrType;
begin
  Result := AddItem(Index) as IXMLAttrType;
end;

{ TXMLAttrType }

function TXMLAttrType.Get_Key: Integer;
begin
  Result := ChildNodes['key'].NodeValue;
end;

function TXMLAttrType.Get_Value: WideString;
begin
  Result := ChildNodes['value'].Text;
end;

{ TXMLProfessionsType }

procedure TXMLProfessionsType.AfterConstruction;
begin
  RegisterChildNode('profession', TXMLProfessionType);
  ItemTag := 'profession';
  ItemInterface := IXMLProfessionType;
  inherited;
end;

function TXMLProfessionsType.Get_Profession(Index: Integer): IXMLProfessionType;
begin
  Result := List[Index] as IXMLProfessionType;
end;

function TXMLProfessionsType.Add: IXMLProfessionType;
begin
  Result := AddItem(-1) as IXMLProfessionType;
end;

function TXMLProfessionsType.Insert(const Index: Integer): IXMLProfessionType;
begin
  Result := AddItem(Index) as IXMLProfessionType;
end;

{ TXMLProfessionType }

function TXMLProfessionType.Get_Abbr: WideString;
begin
  Result := ChildNodes['abbr'].Text;
end;

function TXMLProfessionType.Get_Nom: WideString;
begin
  Result := ChildNodes['nom'].Text;
end;

{ TXMLAttributesType }

procedure TXMLAttributesType.AfterConstruction;
begin
  RegisterChildNode('attribute', TXMLAttributeType);
  ItemTag := 'attribute';
  ItemInterface := IXMLAttributeType;
  inherited;
end;

function TXMLAttributesType.Get_Attribute(Index: Integer): IXMLAttributeType;
begin
  Result := List[Index] as IXMLAttributeType;
end;

function TXMLAttributesType.Add: IXMLAttributeType;
begin
  Result := AddItem(-1) as IXMLAttributeType;
end;

function TXMLAttributesType.Insert(const Index: Integer): IXMLAttributeType;
begin
  Result := AddItem(Index) as IXMLAttributeType;
end;

{ TXMLAttributeType }

function TXMLAttributeType.Get_Abbr: WideString;
begin
  Result := ChildNodes['abbr'].Text;
end;

function TXMLAttributeType.Get_Nom: WideString;
begin
  Result := ChildNodes['nom'].Text;
end;

function TXMLAttributeType.Get_Prof: WideString;
begin
  Result := ChildNodes['prof'].Text;
end;

function TXMLAttributeType.Get_Prof_abbr: WideString;
begin
  Result := ChildNodes['prof_abbr'].Text;
end;

{ TXMLSkillsType }

procedure TXMLSkillsType.AfterConstruction;
begin
  RegisterChildNode('skill', TXMLSkillType);
  ItemTag := 'skill';
  ItemInterface := IXMLSkillType;
  inherited;
end;

function TXMLSkillsType.Get_Skill(Index: Integer): IXMLSkillType;
begin
  Result := List[Index] as IXMLSkillType;
end;

function TXMLSkillsType.Add: IXMLSkillType;
begin
  Result := AddItem(-1) as IXMLSkillType;
end;

function TXMLSkillsType.Insert(const Index: Integer): IXMLSkillType;
begin
  Result := AddItem(Index) as IXMLSkillType;
end;

{ TXMLSkillType }

function TXMLSkillType.Get_Id: Integer;
begin
  Result := ChildNodes['id'].NodeValue;
end;

function TXMLSkillType.Get_Img: Integer;
begin
  Result := ChildNodes['id'].NodeValue;
end;

function TXMLSkillType.Get_Name: WideString;
begin
  Result := ChildNodes['name'].Text;
end;

function TXMLSkillType.Get_Name_id: WideString;
begin
  Result := ChildNodes['name_id'].Text;
end;

function TXMLSkillType.Get_Profession: WideString;
begin
  Result := ChildNodes['profession'].Text;
end;

function TXMLSkillType.Get_Prof: WideString;
begin
  Result := ChildNodes['prof'].Text;
end;

function TXMLSkillType.Get_Attribute: WideString;
begin
  Result := ChildNodes['attribute'].Text;
end;

function TXMLSkillType.Get_Attr: WideString;
begin
  Result := ChildNodes['attr'].Text;
end;

function TXMLSkillType.Get_Type_: WideString;
begin
  Result := ChildNodes['type'].Text;
end;

function TXMLSkillType.Get_Ty: WideString;
begin
  Result := ChildNodes['ty'].Text;
end;

function TXMLSkillType.Get_Chapter: Integer;
begin
  Result := ChildNodes['chapter'].NodeValue;
end;

function TXMLSkillType.Get_Chap: WideString;
begin
  Result := ChildNodes['chap'].Text;
end;

function TXMLSkillType.Get_Pve: Integer;
begin
  Result := ChildNodes['pve'].NodeValue;
end;

function TXMLSkillType.Get_Polymock: Integer;
begin
  Result := ChildNodes['polymock'].NodeValue;
end;

function TXMLSkillType.Get_Monster: Integer;
begin
  Result := ChildNodes['monster'].NodeValue;
end;

function TXMLSkillType.Get_Adrenaline: Integer;
begin
  Result := ChildNodes['adrenaline'].NodeValue;
end;

function TXMLSkillType.Get_Energy: Integer;
var
  tmp: string;
  aNo: integer;
  err: integer;
begin
  tmp := ChildNodes['energy'].NodeValue;
  val(tmp, aNo, err);
  if err=0 then result:=aNo else
  result:=0;
end;

function TXMLSkillType.Get_Recharge: Integer;
begin
  Result := ChildNodes['recharge'].NodeValue;
end;

function TXMLSkillType.Get_Eregen: Integer;
begin
  Result := ChildNodes['eregen'].NodeValue;
end;

function TXMLSkillType.Get_Casting: Extended;
var
  tmp: string;
  aNo: real;
  err: integer;
begin
  tmp := ChildNodes['casting'].NodeValue;
  val(tmp, aNo, err);
  if err=0 then result:=aNo else
  result:=0;
end;

function TXMLSkillType.Get_Elite: Integer;
begin
  Result := ChildNodes['elite'].NodeValue;
end;

function TXMLSkillType.Get_Desc: WideString;
var
t: TXMLSkillType;
begin
  Result := Self.ChildNodes['desc'].Text;
end;

end.