unit params;

interface

uses sysutils, common, msxml, dialogs;

function GetSkillById(id:integer): IXMLDOMNode;
function GetSkillsByProf(prof : string): IXMLDOMNodeList;
function GetSkillsByProfession(prof : string): IXMLDOMNodeList;
function GetSkillsByProfAttr(prof : string; Attr: string): IXMLDOMNodeList;
function GetSkillsByAttr(Attr: string): IXMLDOMNodeList;
function GetProfessions: IXMLDOMNodeList;
function GetAttributes: IXMLDOMNodeList;  
function GetAttributeAttrByNom(nom : string): string;
function GetAttributeNomByAbbr(nom : string): string;
function GetAttributesByProf(prof : string): IXMLDOMNodeList;
function GetAttributesByProfession(prof : string): IXMLDOMNodeList;
function GetProfById(id:integer): string;
function GetProfByName(nom:string): string;
function GetProfIdByAbbr(nom:string): integer;
function GetLangItem(key: string): string;
function GetAttrById(id:integer): string;
function GetAttrIdByAbbr(Abbr:string): integer;
function GetProfByAttr(nom : string): string;

function Skill_Get_Id(node: IXMLDOMNode): Integer;
function Skill_Get_Name(node: IXMLDOMNode): WideString;
function Skill_Get_Name_id(node: IXMLDOMNode): WideString;
function Skill_Get_Profession(node: IXMLDOMNode): WideString;
function Skill_Get_Prof(node: IXMLDOMNode): WideString;
function Skill_Get_Attribute(node: IXMLDOMNode): WideString;
function Skill_Get_Attr(node: IXMLDOMNode): WideString;
function Skill_Get_Type(node: IXMLDOMNode): WideString;
function Skill_Get_Ty(node: IXMLDOMNode): WideString;
function Skill_Get_Chapter(node: IXMLDOMNode): Integer;
function Skill_Get_Chap(node: IXMLDOMNode): WideString;
function Skill_Get_Pve(node: IXMLDOMNode): Integer;
function Skill_Get_Polymock(node: IXMLDOMNode): Integer;
function Skill_Get_Monster(node: IXMLDOMNode): Integer;
function Skill_Get_Adrenaline(node: IXMLDOMNode): Integer;
function Skill_Get_Energy(node: IXMLDOMNode): Integer;
function Skill_Get_Recharge(node: IXMLDOMNode): Integer;
function Skill_Get_Eregen(node: IXMLDOMNode): Integer;
function Skill_Get_Casting(node: IXMLDOMNode): Extended;
function Skill_Get_Elite(node: IXMLDOMNode): Integer;
function Skill_Get_Desc(node: IXMLDOMNode): WideString;
   
function Profession_Get_Nom(node: IXMLDOMNode): WideString;
function Profession_Get_Abbr(node: IXMLDOMNode): WideString;
   
function Attribute_Get_Nom(node: IXMLDOMNode): WideString;
function Attribute_Get_Abbr(node: IXMLDOMNode): WideString;  
function Attribute_Get_Profession(node: IXMLDOMNode): WideString;
function Attribute_Get_Prof(node: IXMLDOMNode): WideString;


implementation

uses main;
                                                       
//-------------------------------------------------------------
function GetAttributeAttrByNom(nom : string): string;
var
  node : IXMLDOMNode;
begin
  Result := '?';
  node := Form1.XMLParams.selectsingleNode('//attribute[@attribute="'+nom+'"]');
  if node<>nil then Result := node.attributes.getNamedItem('attr').Text;
end;
//-------------------------------------------------------------
function GetAttributeNomByAbbr(nom : string): string;
var
  node : IXMLDOMNode;
begin
  Result := '?';
  node := Form1.XMLParams.selectsingleNode('//attribute[@attr="'+nom+'"]');
  if node<>nil then Result := node.attributes.getNamedItem('attribute').Text;
end;                                                          
//-------------------------------------------------------------
function GetProfByAttr(nom : string): string;
var
  node : IXMLDOMNode;
begin
  Result := '?';
  node := Form1.XMLParams.selectsingleNode('//attribute[@attr="'+nom+'"]');
  if node<>nil then Result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function GetAttributesByProfession(prof : string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//attribute[@profession="'+prof+'"]');
end;
//-------------------------------------------------------------
function GetAttributesByProf(prof : string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//attribute[@prof="'+prof+'"]');
end;
//-------------------------------------------------------------
function Attribute_Get_Abbr(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('attr').Text;
end;
//-------------------------------------------------------------
function Attribute_Get_Nom(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('attribute').Text;
end;              
//-------------------------------------------------------------
function Attribute_Get_Profession(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('profession').Text;
end;
//-------------------------------------------------------------
function Attribute_Get_Prof(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function GetAttrIdByAbbr(Abbr:string): integer;
var
  node : IXMLDOMNode;
begin
  result := 0;
  try
    node := Form1.XMLParams.selectsinglenode('//attribute[@attr="'+abbr+'"]');
    result := GetInteger(node.attributes.getNamedItem('id').Text);
  except
  end;
end;               
//-------------------------------------------------------------
function GetProfIdByAbbr(nom:string): integer;
var
  node : IXMLDOMNode;
begin
  result := 0;
  node := Form1.XMLParams.selectsinglenode('//profession[@prof="'+nom+'"]');
  if node<>nil then
    result := getinteger(node.attributes.getNamedItem('id').Text);
end;
//-------------------------------------------------------------
function GetProfByName(nom:string): string;
var
  node : IXMLDOMNode;
begin
  result := '';
  node := Form1.XMLParams.selectsinglenode('//profession[@profession="'+nom+'"]');
  if node<>nil then
    result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function GetProfById(id:integer): string;
var
  node : IXMLDOMNode;
begin
  result := '';
  node := Form1.XMLParams.selectsinglenode('//profession[@id="'+IntToStr(id)+'"]');
  if node<>nil then
    result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function GetAttrById(id:integer): string;
var
  node : IXMLDOMNode;
begin
  node := Form1.XMLParams.selectsinglenode('//attribute[@id="'+IntToStr(id)+'"]');
  if node<>nil then
    result := node.attributes.getNamedItem('attr').Text;
end;
//-------------------------------------------------------------
function GetLangItem(key: string): string;
var
  node : ixmldomnode;
begin
  result := '';
  node := Form1.XMLParams.selectSingleNode('//lang[@key="'+key+'"]');
  if node<>nil then result := node.attributes.getNamedItem('value').text;
end;
//-------------------------------------------------------------
function GetProfessions: IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//profession');
end;
//-------------------------------------------------------------
function GetAttributes: IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//attribute');
end;
//-------------------------------------------------------------
function GetSkillsByProfAttr(prof : string; Attr: string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//skill[@prof_attr="'+prof+'-'+attr+'"]');
end;
//-------------------------------------------------------------
function GetSkillsByAttr(Attr: string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//skill[@attr="'+attr+'"]');
end;
//-------------------------------------------------------------
function GetSkillsByProfession(prof : string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//skill[@profession="'+prof+'"]');
end;
//-------------------------------------------------------------
function GetSkillsByProf(prof : string): IXMLDOMNodeList;
begin
  Result := Form1.XMLParams.selectNodes('//skill[@prof="'+prof+'"]');
end;
//-------------------------------------------------------------
function GetSkillById(id : integer): IXMLDOMNode;
begin
  Result := Form1.XMLParams.SelectsingleNode('//skill[@id="'+IntToStr(id)+'"]');
end;
//-------------------------------------------------------------
function Profession_Get_Abbr(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function Profession_Get_Nom(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('profession').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Id(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('id').Text);
end;
//-------------------------------------------------------------
function Skill_Get_Name(node: IXMLDOMNode): WideString;
begin
  Result := node.selectSingleNode('name').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Name_id(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('name_id').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Profession(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('profession').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Prof(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('prof').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Attribute(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('attribute').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Attr(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('attr').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Type(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('type').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Ty(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('ty').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Chapter(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('chapter').Text);
end;
//-------------------------------------------------------------
function Skill_Get_Chap(node: IXMLDOMNode): WideString;
begin
  Result := node.attributes.getNamedItem('chap').Text;
end;
//-------------------------------------------------------------
function Skill_Get_Pve(node: IXMLDOMNode): Integer;
begin
  Result := node.attributes.getNamedItem('pve').NodeValue;
end;
//-------------------------------------------------------------
function Skill_Get_Polymock(node: IXMLDOMNode): Integer;
begin
  Result := node.attributes.getNamedItem('polymock').NodeValue;
end;
//-------------------------------------------------------------
function Skill_Get_Monster(node: IXMLDOMNode): Integer;
begin
  Result := node.attributes.getNamedItem('monster').NodeValue;
end;
//-------------------------------------------------------------
function Skill_Get_Adrenaline(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('adrenaline').Text);
end;
//-------------------------------------------------------------
function Skill_Get_Energy(node: IXMLDOMNode): Integer;
var
  tmp: string;
  aNo: integer;
  err: integer;
begin
  tmp := node.attributes.getNamedItem('energy').text;
  val(tmp, aNo, err);
  if err=0 then result:=aNo else
  result:=0;
end;
//-------------------------------------------------------------
function Skill_Get_Recharge(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('recharge').text);
end;
//-------------------------------------------------------------
function Skill_Get_Eregen(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('eregen').text);
end;
//-------------------------------------------------------------
function Skill_Get_Casting(node: IXMLDOMNode): Extended;
var
  tmp: string;
  aNo: real;
  err: integer;
begin
  tmp := node.attributes.getNamedItem('casting').text;
  val(tmp, aNo, err);
  if err=0 then result:=aNo else
  result:=0;
end;
//-------------------------------------------------------------
function Skill_Get_Elite(node: IXMLDOMNode): Integer;
begin
  Result := GetInteger(node.attributes.getNamedItem('elite').text);
end;
//-------------------------------------------------------------
function Skill_Get_Desc(node: IXMLDOMNode): WideString;
begin
  Result := node.selectSingleNode('desc').Text;
end;
//-------------------------------------------------------------
end.